(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('big.js'), require('echarts')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'big.js', 'echarts'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.EchartsReadymadeStack = {}, global.React, global.Big, global.echarts));
})(this, (function (exports, React, Big, echarts) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
  var Big__default = /*#__PURE__*/_interopDefaultLegacy(Big);
  var echarts__namespace = /*#__PURE__*/_interopNamespace(echarts);

  var clone = {exports: {}};

  (function (module) {
  var clone = (function() {

  function _instanceof(obj, type) {
    return type != null && obj instanceof type;
  }

  var nativeMap;
  try {
    nativeMap = Map;
  } catch(_) {
    // maybe a reference error because no `Map`. Give it a dummy value that no
    // value will ever be an instanceof.
    nativeMap = function() {};
  }

  var nativeSet;
  try {
    nativeSet = Set;
  } catch(_) {
    nativeSet = function() {};
  }

  var nativePromise;
  try {
    nativePromise = Promise;
  } catch(_) {
    nativePromise = function() {};
  }

  /**
   * Clones (copies) an Object using deep copying.
   *
   * This function supports circular references by default, but if you are certain
   * there are no circular references in your object, you can save some CPU time
   * by calling clone(obj, false).
   *
   * Caution: if `circular` is false and `parent` contains circular references,
   * your program may enter an infinite loop and crash.
   *
   * @param `parent` - the object to be cloned
   * @param `circular` - set to true if the object to be cloned may contain
   *    circular references. (optional - true by default)
   * @param `depth` - set to a number if the object is only to be cloned to
   *    a particular depth. (optional - defaults to Infinity)
   * @param `prototype` - sets the prototype to be used when cloning an object.
   *    (optional - defaults to parent prototype).
   * @param `includeNonEnumerable` - set to true if the non-enumerable properties
   *    should be cloned as well. Non-enumerable properties on the prototype
   *    chain will be ignored. (optional - false by default)
  */
  function clone(parent, circular, depth, prototype, includeNonEnumerable) {
    if (typeof circular === 'object') {
      depth = circular.depth;
      prototype = circular.prototype;
      includeNonEnumerable = circular.includeNonEnumerable;
      circular = circular.circular;
    }
    // maintain two arrays for circular references, where corresponding parents
    // and children have the same index
    var allParents = [];
    var allChildren = [];

    var useBuffer = typeof Buffer != 'undefined';

    if (typeof circular == 'undefined')
      circular = true;

    if (typeof depth == 'undefined')
      depth = Infinity;

    // recurse this function so we don't reset allParents and allChildren
    function _clone(parent, depth) {
      // cloning null always returns null
      if (parent === null)
        return null;

      if (depth === 0)
        return parent;

      var child;
      var proto;
      if (typeof parent != 'object') {
        return parent;
      }

      if (_instanceof(parent, nativeMap)) {
        child = new nativeMap();
      } else if (_instanceof(parent, nativeSet)) {
        child = new nativeSet();
      } else if (_instanceof(parent, nativePromise)) {
        child = new nativePromise(function (resolve, reject) {
          parent.then(function(value) {
            resolve(_clone(value, depth - 1));
          }, function(err) {
            reject(_clone(err, depth - 1));
          });
        });
      } else if (clone.__isArray(parent)) {
        child = [];
      } else if (clone.__isRegExp(parent)) {
        child = new RegExp(parent.source, __getRegExpFlags(parent));
        if (parent.lastIndex) child.lastIndex = parent.lastIndex;
      } else if (clone.__isDate(parent)) {
        child = new Date(parent.getTime());
      } else if (useBuffer && Buffer.isBuffer(parent)) {
        if (Buffer.allocUnsafe) {
          // Node.js >= 4.5.0
          child = Buffer.allocUnsafe(parent.length);
        } else {
          // Older Node.js versions
          child = new Buffer(parent.length);
        }
        parent.copy(child);
        return child;
      } else if (_instanceof(parent, Error)) {
        child = Object.create(parent);
      } else {
        if (typeof prototype == 'undefined') {
          proto = Object.getPrototypeOf(parent);
          child = Object.create(proto);
        }
        else {
          child = Object.create(prototype);
          proto = prototype;
        }
      }

      if (circular) {
        var index = allParents.indexOf(parent);

        if (index != -1) {
          return allChildren[index];
        }
        allParents.push(parent);
        allChildren.push(child);
      }

      if (_instanceof(parent, nativeMap)) {
        parent.forEach(function(value, key) {
          var keyChild = _clone(key, depth - 1);
          var valueChild = _clone(value, depth - 1);
          child.set(keyChild, valueChild);
        });
      }
      if (_instanceof(parent, nativeSet)) {
        parent.forEach(function(value) {
          var entryChild = _clone(value, depth - 1);
          child.add(entryChild);
        });
      }

      for (var i in parent) {
        var attrs;
        if (proto) {
          attrs = Object.getOwnPropertyDescriptor(proto, i);
        }

        if (attrs && attrs.set == null) {
          continue;
        }
        child[i] = _clone(parent[i], depth - 1);
      }

      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(parent);
        for (var i = 0; i < symbols.length; i++) {
          // Don't need to worry about cloning a symbol because it is a primitive,
          // like a number or string.
          var symbol = symbols[i];
          var descriptor = Object.getOwnPropertyDescriptor(parent, symbol);
          if (descriptor && !descriptor.enumerable && !includeNonEnumerable) {
            continue;
          }
          child[symbol] = _clone(parent[symbol], depth - 1);
          if (!descriptor.enumerable) {
            Object.defineProperty(child, symbol, {
              enumerable: false
            });
          }
        }
      }

      if (includeNonEnumerable) {
        var allPropertyNames = Object.getOwnPropertyNames(parent);
        for (var i = 0; i < allPropertyNames.length; i++) {
          var propertyName = allPropertyNames[i];
          var descriptor = Object.getOwnPropertyDescriptor(parent, propertyName);
          if (descriptor && descriptor.enumerable) {
            continue;
          }
          child[propertyName] = _clone(parent[propertyName], depth - 1);
          Object.defineProperty(child, propertyName, {
            enumerable: false
          });
        }
      }

      return child;
    }

    return _clone(parent, depth);
  }

  /**
   * Simple flat clone using prototype, accepts only objects, usefull for property
   * override on FLAT configuration object (no nested props).
   *
   * USE WITH CAUTION! This may not behave as you wish if you do not know how this
   * works.
   */
  clone.clonePrototype = function clonePrototype(parent) {
    if (parent === null)
      return null;

    var c = function () {};
    c.prototype = parent;
    return new c();
  };

  // private utility functions

  function __objToStr(o) {
    return Object.prototype.toString.call(o);
  }
  clone.__objToStr = __objToStr;

  function __isDate(o) {
    return typeof o === 'object' && __objToStr(o) === '[object Date]';
  }
  clone.__isDate = __isDate;

  function __isArray(o) {
    return typeof o === 'object' && __objToStr(o) === '[object Array]';
  }
  clone.__isArray = __isArray;

  function __isRegExp(o) {
    return typeof o === 'object' && __objToStr(o) === '[object RegExp]';
  }
  clone.__isRegExp = __isRegExp;

  function __getRegExpFlags(re) {
    var flags = '';
    if (re.global) flags += 'g';
    if (re.ignoreCase) flags += 'i';
    if (re.multiline) flags += 'm';
    return flags;
  }
  clone.__getRegExpFlags = __getRegExpFlags;

  return clone;
  })();

  if (module.exports) {
    module.exports = clone;
  }
  }(clone));

  var cloneDeep = clone.exports;

  var MAX_DP = 1e6, MAX_POWER = 1e6, NAME = "[big.js] ", INVALID = NAME + "Invalid ", INVALID_DP = INVALID + "decimal places", INVALID_RM = INVALID + "rounding mode", DIV_BY_ZERO = NAME + "Division by zero", P = {}, UNDEFINED = void 0;
  function round(x, sd, rm, more) {
    var xc = x.c;
    if (rm === UNDEFINED)
      rm = x.constructor.RM;
    if (rm !== 0 && rm !== 1 && rm !== 2 && rm !== 3) {
      throw Error(INVALID_RM);
    }
    if (sd < 1) {
      more = rm === 3 && (more || !!xc[0]) || sd === 0 && (rm === 1 && xc[0] >= 5 || rm === 2 && (xc[0] > 5 || xc[0] === 5 && (more || xc[1] !== UNDEFINED)));
      xc.length = 1;
      if (more) {
        x.e = x.e - sd + 1;
        xc[0] = 1;
      } else {
        xc[0] = x.e = 0;
      }
    } else if (sd < xc.length) {
      more = rm === 1 && xc[sd] >= 5 || rm === 2 && (xc[sd] > 5 || xc[sd] === 5 && (more || xc[sd + 1] !== UNDEFINED || xc[sd - 1] & 1)) || rm === 3 && (more || !!xc[0]);
      xc.length = sd--;
      if (more) {
        for (; ++xc[sd] > 9; ) {
          xc[sd] = 0;
          if (!sd--) {
            ++x.e;
            xc.unshift(1);
          }
        }
      }
      for (sd = xc.length; !xc[--sd]; )
        xc.pop();
    }
    return x;
  }
  function stringify(x, doExponential, isNonzero) {
    var e = x.e, s = x.c.join(""), n = s.length;
    if (doExponential) {
      s = s.charAt(0) + (n > 1 ? "." + s.slice(1) : "") + (e < 0 ? "e" : "e+") + e;
    } else if (e < 0) {
      for (; ++e; )
        s = "0" + s;
      s = "0." + s;
    } else if (e > 0) {
      if (++e > n) {
        for (e -= n; e--; )
          s += "0";
      } else if (e < n) {
        s = s.slice(0, e) + "." + s.slice(e);
      }
    } else if (n > 1) {
      s = s.charAt(0) + "." + s.slice(1);
    }
    return x.s < 0 && isNonzero ? "-" + s : s;
  }
  P.abs = function() {
    var x = new this.constructor(this);
    x.s = 1;
    return x;
  };
  P.cmp = function(y) {
    var isneg, x = this, xc = x.c, yc = (y = new x.constructor(y)).c, i = x.s, j = y.s, k = x.e, l = y.e;
    if (!xc[0] || !yc[0])
      return !xc[0] ? !yc[0] ? 0 : -j : i;
    if (i != j)
      return i;
    isneg = i < 0;
    if (k != l)
      return k > l ^ isneg ? 1 : -1;
    j = (k = xc.length) < (l = yc.length) ? k : l;
    for (i = -1; ++i < j; ) {
      if (xc[i] != yc[i])
        return xc[i] > yc[i] ^ isneg ? 1 : -1;
    }
    return k == l ? 0 : k > l ^ isneg ? 1 : -1;
  };
  P.div = function(y) {
    var x = this, Big2 = x.constructor, a = x.c, b = (y = new Big2(y)).c, k = x.s == y.s ? 1 : -1, dp = Big2.DP;
    if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
      throw Error(INVALID_DP);
    }
    if (!b[0]) {
      throw Error(DIV_BY_ZERO);
    }
    if (!a[0]) {
      y.s = k;
      y.c = [y.e = 0];
      return y;
    }
    var bl, bt, n, cmp, ri, bz = b.slice(), ai = bl = b.length, al = a.length, r = a.slice(0, bl), rl = r.length, q = y, qc = q.c = [], qi = 0, p = dp + (q.e = x.e - y.e) + 1;
    q.s = k;
    k = p < 0 ? 0 : p;
    bz.unshift(0);
    for (; rl++ < bl; )
      r.push(0);
    do {
      for (n = 0; n < 10; n++) {
        if (bl != (rl = r.length)) {
          cmp = bl > rl ? 1 : -1;
        } else {
          for (ri = -1, cmp = 0; ++ri < bl; ) {
            if (b[ri] != r[ri]) {
              cmp = b[ri] > r[ri] ? 1 : -1;
              break;
            }
          }
        }
        if (cmp < 0) {
          for (bt = rl == bl ? b : bz; rl; ) {
            if (r[--rl] < bt[rl]) {
              ri = rl;
              for (; ri && !r[--ri]; )
                r[ri] = 9;
              --r[ri];
              r[rl] += 10;
            }
            r[rl] -= bt[rl];
          }
          for (; !r[0]; )
            r.shift();
        } else {
          break;
        }
      }
      qc[qi++] = cmp ? n : ++n;
      if (r[0] && cmp)
        r[rl] = a[ai] || 0;
      else
        r = [a[ai]];
    } while ((ai++ < al || r[0] !== UNDEFINED) && k--);
    if (!qc[0] && qi != 1) {
      qc.shift();
      q.e--;
      p--;
    }
    if (qi > p)
      round(q, p, Big2.RM, r[0] !== UNDEFINED);
    return q;
  };
  P.eq = function(y) {
    return this.cmp(y) === 0;
  };
  P.gt = function(y) {
    return this.cmp(y) > 0;
  };
  P.gte = function(y) {
    return this.cmp(y) > -1;
  };
  P.lt = function(y) {
    return this.cmp(y) < 0;
  };
  P.lte = function(y) {
    return this.cmp(y) < 1;
  };
  P.minus = P.sub = function(y) {
    var i, j, t, xlty, x = this, Big2 = x.constructor, a = x.s, b = (y = new Big2(y)).s;
    if (a != b) {
      y.s = -b;
      return x.plus(y);
    }
    var xc = x.c.slice(), xe = x.e, yc = y.c, ye = y.e;
    if (!xc[0] || !yc[0]) {
      if (yc[0]) {
        y.s = -b;
      } else if (xc[0]) {
        y = new Big2(x);
      } else {
        y.s = 1;
      }
      return y;
    }
    if (a = xe - ye) {
      if (xlty = a < 0) {
        a = -a;
        t = xc;
      } else {
        ye = xe;
        t = yc;
      }
      t.reverse();
      for (b = a; b--; )
        t.push(0);
      t.reverse();
    } else {
      j = ((xlty = xc.length < yc.length) ? xc : yc).length;
      for (a = b = 0; b < j; b++) {
        if (xc[b] != yc[b]) {
          xlty = xc[b] < yc[b];
          break;
        }
      }
    }
    if (xlty) {
      t = xc;
      xc = yc;
      yc = t;
      y.s = -y.s;
    }
    if ((b = (j = yc.length) - (i = xc.length)) > 0)
      for (; b--; )
        xc[i++] = 0;
    for (b = i; j > a; ) {
      if (xc[--j] < yc[j]) {
        for (i = j; i && !xc[--i]; )
          xc[i] = 9;
        --xc[i];
        xc[j] += 10;
      }
      xc[j] -= yc[j];
    }
    for (; xc[--b] === 0; )
      xc.pop();
    for (; xc[0] === 0; ) {
      xc.shift();
      --ye;
    }
    if (!xc[0]) {
      y.s = 1;
      xc = [ye = 0];
    }
    y.c = xc;
    y.e = ye;
    return y;
  };
  P.mod = function(y) {
    var ygtx, x = this, Big2 = x.constructor, a = x.s, b = (y = new Big2(y)).s;
    if (!y.c[0]) {
      throw Error(DIV_BY_ZERO);
    }
    x.s = y.s = 1;
    ygtx = y.cmp(x) == 1;
    x.s = a;
    y.s = b;
    if (ygtx)
      return new Big2(x);
    a = Big2.DP;
    b = Big2.RM;
    Big2.DP = Big2.RM = 0;
    x = x.div(y);
    Big2.DP = a;
    Big2.RM = b;
    return this.minus(x.times(y));
  };
  P.plus = P.add = function(y) {
    var e, k, t, x = this, Big2 = x.constructor;
    y = new Big2(y);
    if (x.s != y.s) {
      y.s = -y.s;
      return x.minus(y);
    }
    var xe = x.e, xc = x.c, ye = y.e, yc = y.c;
    if (!xc[0] || !yc[0]) {
      if (!yc[0]) {
        if (xc[0]) {
          y = new Big2(x);
        } else {
          y.s = x.s;
        }
      }
      return y;
    }
    xc = xc.slice();
    if (e = xe - ye) {
      if (e > 0) {
        ye = xe;
        t = yc;
      } else {
        e = -e;
        t = xc;
      }
      t.reverse();
      for (; e--; )
        t.push(0);
      t.reverse();
    }
    if (xc.length - yc.length < 0) {
      t = yc;
      yc = xc;
      xc = t;
    }
    e = yc.length;
    for (k = 0; e; xc[e] %= 10)
      k = (xc[--e] = xc[e] + yc[e] + k) / 10 | 0;
    if (k) {
      xc.unshift(k);
      ++ye;
    }
    for (e = xc.length; xc[--e] === 0; )
      xc.pop();
    y.c = xc;
    y.e = ye;
    return y;
  };
  P.pow = function(n) {
    var x = this, one = new x.constructor("1"), y = one, isneg = n < 0;
    if (n !== ~~n || n < -MAX_POWER || n > MAX_POWER) {
      throw Error(INVALID + "exponent");
    }
    if (isneg)
      n = -n;
    for (; ; ) {
      if (n & 1)
        y = y.times(x);
      n >>= 1;
      if (!n)
        break;
      x = x.times(x);
    }
    return isneg ? one.div(y) : y;
  };
  P.prec = function(sd, rm) {
    if (sd !== ~~sd || sd < 1 || sd > MAX_DP) {
      throw Error(INVALID + "precision");
    }
    return round(new this.constructor(this), sd, rm);
  };
  P.round = function(dp, rm) {
    if (dp === UNDEFINED)
      dp = 0;
    else if (dp !== ~~dp || dp < -MAX_DP || dp > MAX_DP) {
      throw Error(INVALID_DP);
    }
    return round(new this.constructor(this), dp + this.e + 1, rm);
  };
  P.sqrt = function() {
    var r, c, t, x = this, Big2 = x.constructor, s = x.s, e = x.e, half = new Big2("0.5");
    if (!x.c[0])
      return new Big2(x);
    if (s < 0) {
      throw Error(NAME + "No square root");
    }
    s = Math.sqrt(x + "");
    if (s === 0 || s === 1 / 0) {
      c = x.c.join("");
      if (!(c.length + e & 1))
        c += "0";
      s = Math.sqrt(c);
      e = ((e + 1) / 2 | 0) - (e < 0 || e & 1);
      r = new Big2((s == 1 / 0 ? "5e" : (s = s.toExponential()).slice(0, s.indexOf("e") + 1)) + e);
    } else {
      r = new Big2(s + "");
    }
    e = r.e + (Big2.DP += 4);
    do {
      t = r;
      r = half.times(t.plus(x.div(t)));
    } while (t.c.slice(0, e).join("") !== r.c.slice(0, e).join(""));
    return round(r, (Big2.DP -= 4) + r.e + 1, Big2.RM);
  };
  P.times = P.mul = function(y) {
    var c, x = this, Big2 = x.constructor, xc = x.c, yc = (y = new Big2(y)).c, a = xc.length, b = yc.length, i = x.e, j = y.e;
    y.s = x.s == y.s ? 1 : -1;
    if (!xc[0] || !yc[0]) {
      y.c = [y.e = 0];
      return y;
    }
    y.e = i + j;
    if (a < b) {
      c = xc;
      xc = yc;
      yc = c;
      j = a;
      a = b;
      b = j;
    }
    for (c = new Array(j = a + b); j--; )
      c[j] = 0;
    for (i = b; i--; ) {
      b = 0;
      for (j = a + i; j > i; ) {
        b = c[j] + yc[i] * xc[j - i - 1] + b;
        c[j--] = b % 10;
        b = b / 10 | 0;
      }
      c[j] = b;
    }
    if (b)
      ++y.e;
    else
      c.shift();
    for (i = c.length; !c[--i]; )
      c.pop();
    y.c = c;
    return y;
  };
  P.toExponential = function(dp, rm) {
    var x = this, n = x.c[0];
    if (dp !== UNDEFINED) {
      if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
        throw Error(INVALID_DP);
      }
      x = round(new x.constructor(x), ++dp, rm);
      for (; x.c.length < dp; )
        x.c.push(0);
    }
    return stringify(x, true, !!n);
  };
  P.toFixed = function(dp, rm) {
    var x = this, n = x.c[0];
    if (dp !== UNDEFINED) {
      if (dp !== ~~dp || dp < 0 || dp > MAX_DP) {
        throw Error(INVALID_DP);
      }
      x = round(new x.constructor(x), dp + x.e + 1, rm);
      for (dp = dp + x.e + 1; x.c.length < dp; )
        x.c.push(0);
    }
    return stringify(x, false, !!n);
  };
  P.toJSON = P.toString = function() {
    var x = this, Big2 = x.constructor;
    return stringify(x, x.e <= Big2.NE || x.e >= Big2.PE, !!x.c[0]);
  };
  P.toNumber = function() {
    var n = Number(stringify(this, true, true));
    if (this.constructor.strict === true && !this.eq(n.toString())) {
      throw Error(NAME + "Imprecise conversion");
    }
    return n;
  };
  P.toPrecision = function(sd, rm) {
    var x = this, Big2 = x.constructor, n = x.c[0];
    if (sd !== UNDEFINED) {
      if (sd !== ~~sd || sd < 1 || sd > MAX_DP) {
        throw Error(INVALID + "precision");
      }
      x = round(new Big2(x), sd, rm);
      for (; x.c.length < sd; )
        x.c.push(0);
    }
    return stringify(x, sd <= x.e || x.e <= Big2.NE || x.e >= Big2.PE, !!n);
  };
  P.valueOf = function() {
    var x = this, Big2 = x.constructor;
    if (Big2.strict === true) {
      throw Error(NAME + "valueOf disallowed");
    }
    return stringify(x, x.e <= Big2.NE || x.e >= Big2.PE, true);
  };
  var __defProp$1 = Object.defineProperty;
  var __getOwnPropSymbols$1 = Object.getOwnPropertySymbols;
  var __hasOwnProp$1 = Object.prototype.hasOwnProperty;
  var __propIsEnum$1 = Object.prototype.propertyIsEnumerable;
  var __defNormalProp$1 = (obj, key, value) => key in obj ? __defProp$1(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
  var __spreadValues$1 = (a, b) => {
    for (var prop in b || (b = {}))
      if (__hasOwnProp$1.call(b, prop))
        __defNormalProp$1(a, prop, b[prop]);
    if (__getOwnPropSymbols$1)
      for (var prop of __getOwnPropSymbols$1(b)) {
        if (__propIsEnum$1.call(b, prop))
          __defNormalProp$1(a, prop, b[prop]);
      }
    return a;
  };
  const mergeOption = (baseOptions, userOptions = {}) => {
    const _baseOptions = baseOptions || {};
    const _userOptions = userOptions || {};
    const _mergeOptions = __spreadValues$1(__spreadValues$1({}, _baseOptions), _userOptions);
    return _mergeOptions;
  };
  const truncate = (str, n) => {
    const r = /[^\x00-\xff]/g;
    let m;
    if (!str) {
      return "";
    }
    if (str.replace(r, "**").length > n) {
      m = Math.floor(n / 2);
      for (let i = m, l = str.length; i < l; i++) {
        if (str.slice(0, i).replace(r, "**").length >= n) {
          return str.slice(0, i) + "...";
        }
      }
    }
    return str;
  };
  function numberWithCommas(x) {
    if (x === null || typeof x === "undefined") {
      return "--";
    }
    const parts = x.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
  }
  React__default["default"].createContext({});
  const buildChartOption = (chartOptions, settings, chartType) => {
    var _a;
    const _option = chartOptions || {};
    const { legendPosition = "top" } = settings || {};
    if (legendPosition) {
      switch (legendPosition) {
        case "top":
          _option.legend.top = 60;
          _option.legend.bottom = "auto";
          _option.legend.left = "center";
          _option.legend.padding = [5, 5];
          _option.grid.top = 110;
          _option.grid.left = chartType == "scatter" ? 70 : 20;
          _option.grid.right = chartType == "scatter" ? 100 : chartType == "bar-horizontal" ? 50 : 20;
          _option.grid.bottom = chartType == "scatter" ? 100 : 45;
          _option.legend.orient = "horizontal";
          break;
        case "bottom":
          _option.legend.top = "auto";
          _option.legend.bottom = chartType == "scatter" ? 40 : 20;
          _option.legend.left = "center";
          _option.legend.padding = [5, 5];
          _option.grid.top = 70;
          _option.grid.left = chartType == "scatter" ? 70 : 20;
          _option.grid.right = chartType == "scatter" ? 50 : chartType == "bar-horizontal" ? 50 : 20;
          _option.grid.bottom = chartType == "scatter" ? 100 : 45;
          _option.legend.orient = "horizontal";
          break;
        case "left":
          _option.legend.top = 60;
          _option.legend.bottom = 60;
          _option.legend.left = 20;
          _option.legend.right = "auto";
          _option.legend.padding = [5, 5];
          _option.grid.top = 70;
          _option.grid.left = 150;
          _option.grid.right = chartType == "scatter" ? 50 : 20;
          _option.grid.bottom = chartType == "scatter" ? 100 : 20;
          _option.legend.orient = "vertical";
          break;
        case "right":
          _option.legend.top = 60;
          _option.legend.bottom = 60;
          _option.legend.left = "auto";
          _option.legend.right = chartType == "scatter" ? 50 : 20;
          _option.legend.padding = [5, 5];
          _option.grid.top = 70;
          _option.grid.left = chartType == "scatter" ? 70 : 20;
          _option.grid.right = chartType == "scatter" ? 170 : 200;
          _option.grid.bottom = chartType == "scatter" ? 100 : 20;
          _option.legend.orient = "vertical";
          break;
        default:
          _option.legend.top = "auto";
          _option.legend.bottom = "6%";
          _option.legend.left = "center";
          _option.grid.top = "18%";
          _option.grid.left = "8%";
          _option.grid.right = "8%";
          _option.grid.bottom = "15%";
          break;
      }
      if (_option.legend.show == false) {
        _option.legend.top = 60;
        _option.legend.bottom = "auto";
        _option.legend.left = "center";
        _option.legend.padding = [5, 5];
        _option.grid.top = 100;
        _option.grid.left = 20;
        _option.grid.right = chartType == "scatter" ? 50 : 20;
        _option.grid.bottom = chartType == "scatter" ? 60 : 20;
      }
    } else {
      _option.legend.top = "auto";
      _option.legend.bottom = "6%";
      _option.legend.left = "center";
      _option.grid.top = "18%";
      _option.grid.left = "8%";
      _option.grid.right = "8%";
      _option.grid.bottom = "15%";
      _option.legend.orient = "horizontal";
    }
    const iconLineWithRing = "path://M14,4h-2.1C11.4,1.7,9.4,0,7,0S2.6,1.7,2.1,4H0v2h2.1c0.5,2.3,2.5,4,4.9,4s4.4-1.7,4.9-4H14V4z M7,8  C5.3,8,4,6.7,4,5s1.3-3,3-3s3,1.3,3,3S8.7,8,7,8z";
    if (chartType == "pie") {
      _option.legend.data = _option.series[0] && _option.series[0].data.map((item) => {
        const textStyle = {
          padding: [2, 0, 0, 0]
        };
        return {
          name: item.name,
          icon: "circle",
          textStyle
        };
      });
    } else {
      const _legendData = (_a = _option.series) == null ? void 0 : _a.map((item) => {
        let icon = "circle";
        const textStyle = {
          padding: [2, 0, 0, 0]
        };
        switch (item.type) {
          case "bar":
            icon = "circle";
            break;
          case "line":
            icon = iconLineWithRing;
            break;
        }
        return {
          name: `${item.name}`,
          icon,
          textStyle
        };
      });
      if (_option.legend.show && legendPosition && ["left", "right"].includes(legendPosition) && (chartType == "stack" || chartType == "line-stack")) {
        _option.legend.data = _legendData.reverse();
        _option.tooltip.formatter = function(data) {
          return `<div>${data[0].name}</div>${data.reverse().map((d) => {
          switch (d.seriesType) {
            case "pie":
              return `<div>
                        <span style="display:inline-block;margin-right:5px;border-radius:10px;width:9px;height:9px;background-color:${d.color}"></span>
                        <span>${d.data.label ? d.data.label.formatter(d, true) : d.data.value}</span>
                    </div>`;
            default:
              return `<div>
                        <span style="display:inline-block;margin-right:5px;border-radius:10px;width:9px;height:9px;background-color:${d.color}"></span>
                        <span>${d.seriesName}:</span>
                        <span>${d.data.label ? d.data.label.formatter(d, true) : d.data.value}</span>
                    </div>`;
          }
        }).join("")}`;
        };
      } else {
        _option.legend.data = _legendData;
      }
    }
    _option.legend.formatter = (text) => {
      if (isNaN(text)) {
        return truncate(text, 12);
      } else {
        return text;
      }
    };
    _option.tooltip.trigger = ["pie", "scatter"].includes(chartType) ? "item" : "axis";
    return _option;
  };

  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise */

  var extendStatics = function(d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
      return extendStatics(d, b);
  };

  function __extends(d, b) {
      if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }

  var __assign = function() {
      __assign = Object.assign || function __assign(t) {
          for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
          }
          return t;
      };
      return __assign.apply(this, arguments);
  };

  var lib = {};

  var sensorPool = {};

  var id = {};

  (function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  /**
   * Created by hustcc on 18/6/9.
   * Contract: i@hust.cc
   */
  var id = 1;
  /**
   * generate unique id in application
   * @return {string}
   */

  var _default = function _default() {
    return "".concat(id++);
  };

  exports["default"] = _default;
  }(id));

  var sensors = {};

  var object = {};

  var debounce = {};

  (function (exports) {

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  /**
   * Created by hustcc on 18/6/9.
   * Contract: i@hust.cc
   */
  var _default = function _default(fn) {
    var delay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 60;
    var timer = null;
    return function () {
      var _this = this;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      clearTimeout(timer);
      timer = setTimeout(function () {
        fn.apply(_this, args);
      }, delay);
    };
  };

  exports["default"] = _default;
  }(debounce));

  var constant = {};

  Object.defineProperty(constant, "__esModule", {
    value: true
  });
  constant.SensorTabIndex = constant.SensorClassName = constant.SizeSensorId = void 0;

  /**
   * Created by hustcc on 18/6/9.
   * Contract: i@hust.cc
   */
  var SizeSensorId = 'size-sensor-id';
  constant.SizeSensorId = SizeSensorId;
  var SensorClassName = 'size-sensor-object';
  constant.SensorClassName = SensorClassName;
  var SensorTabIndex = '-1';
  constant.SensorTabIndex = SensorTabIndex;

  Object.defineProperty(object, "__esModule", {
    value: true
  });
  object.createSensor = void 0;

  var _debounce$1 = _interopRequireDefault$2(debounce);

  var _constant$1 = constant;

  function _interopRequireDefault$2(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

  /**
   * Created by hustcc on 18/6/9.
   * Contract: i@hust.cc
   */
  var createSensor$2 = function createSensor(element) {
    var sensor = undefined; // callback

    var listeners = [];
    /**
     * create object DOM of sensor
     * @returns {HTMLObjectElement}
     */

    var newSensor = function newSensor() {
      // adjust style
      if (getComputedStyle(element).position === 'static') {
        element.style.position = 'relative';
      }

      var obj = document.createElement('object');

      obj.onload = function () {
        obj.contentDocument.defaultView.addEventListener('resize', resizeListener); // 直接触发一次 resize

        resizeListener();
      };

      obj.style.display = 'block';
      obj.style.position = 'absolute';
      obj.style.top = '0';
      obj.style.left = '0';
      obj.style.height = '100%';
      obj.style.width = '100%';
      obj.style.overflow = 'hidden';
      obj.style.pointerEvents = 'none';
      obj.style.zIndex = '-1';
      obj.style.opacity = '0';
      obj.setAttribute('class', _constant$1.SensorClassName);
      obj.setAttribute('tabindex', _constant$1.SensorTabIndex);
      obj.type = 'text/html'; // append into dom

      element.appendChild(obj); // for ie, should set data attribute delay, or will be white screen

      obj.data = 'about:blank';
      return obj;
    };
    /**
     * trigger listeners
     */


    var resizeListener = (0, _debounce$1["default"])(function () {
      // trigger all listener
      listeners.forEach(function (listener) {
        listener(element);
      });
    });
    /**
     * listen with one callback function
     * @param cb
     */

    var bind = function bind(cb) {
      // if not exist sensor, then create one
      if (!sensor) {
        sensor = newSensor();
      }

      if (listeners.indexOf(cb) === -1) {
        listeners.push(cb);
      }
    };
    /**
     * destroy all
     */


    var destroy = function destroy() {
      if (sensor && sensor.parentNode) {
        if (sensor.contentDocument) {
          // remote event
          sensor.contentDocument.defaultView.removeEventListener('resize', resizeListener);
        } // remove dom


        sensor.parentNode.removeChild(sensor); // initial variable

        sensor = undefined;
        listeners = [];
      }
    };
    /**
     * cancel listener bind
     * @param cb
     */


    var unbind = function unbind(cb) {
      var idx = listeners.indexOf(cb);

      if (idx !== -1) {
        listeners.splice(idx, 1);
      } // no listener, and sensor is exist
      // then destroy the sensor


      if (listeners.length === 0 && sensor) {
        destroy();
      }
    };

    return {
      element: element,
      bind: bind,
      destroy: destroy,
      unbind: unbind
    };
  };

  object.createSensor = createSensor$2;

  var resizeObserver = {};

  Object.defineProperty(resizeObserver, "__esModule", {
    value: true
  });
  resizeObserver.createSensor = void 0;

  var _debounce = _interopRequireDefault$1(debounce);

  function _interopRequireDefault$1(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

  /**
   * Created by hustcc on 18/7/5.
   * Contract: i@hust.cc
   */
  var createSensor$1 = function createSensor(element) {
    var sensor = undefined; // callback

    var listeners = [];
    /**
     * trigger listeners
     */

    var resizeListener = (0, _debounce["default"])(function () {
      // trigger all
      listeners.forEach(function (listener) {
        listener(element);
      });
    });
    /**
     * create ResizeObserver sensor
     * @returns
     */

    var newSensor = function newSensor() {
      var s = new ResizeObserver(resizeListener); // listen element

      s.observe(element); // trigger once

      resizeListener();
      return s;
    };
    /**
     * listen with callback
     * @param cb
     */


    var bind = function bind(cb) {
      if (!sensor) {
        sensor = newSensor();
      }

      if (listeners.indexOf(cb) === -1) {
        listeners.push(cb);
      }
    };
    /**
     * destroy
     */


    var destroy = function destroy() {
      sensor.disconnect();
      listeners = [];
      sensor = undefined;
    };
    /**
     * cancel bind
     * @param cb
     */


    var unbind = function unbind(cb) {
      var idx = listeners.indexOf(cb);

      if (idx !== -1) {
        listeners.splice(idx, 1);
      } // no listener, and sensor is exist
      // then destroy the sensor


      if (listeners.length === 0 && sensor) {
        destroy();
      }
    };

    return {
      element: element,
      bind: bind,
      destroy: destroy,
      unbind: unbind
    };
  };

  resizeObserver.createSensor = createSensor$1;

  Object.defineProperty(sensors, "__esModule", {
    value: true
  });
  sensors.createSensor = void 0;

  var _object = object;

  var _resizeObserver = resizeObserver;

  /**
   * Created by hustcc on 18/7/5.
   * Contract: i@hust.cc
   */

  /**
   * sensor strategies
   */
  // export const createSensor = createObjectSensor;
  var createSensor = typeof ResizeObserver !== 'undefined' ? _resizeObserver.createSensor : _object.createSensor;
  sensors.createSensor = createSensor;

  Object.defineProperty(sensorPool, "__esModule", {
    value: true
  });
  sensorPool.removeSensor = sensorPool.getSensor = void 0;

  var _id = _interopRequireDefault(id);

  var _sensors = sensors;

  var _constant = constant;

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

  /**
   * Created by hustcc on 18/6/9.
   * Contract: i@hust.cc
   */

  /**
   * all the sensor objects.
   * sensor pool
   */
  var Sensors = {};
  /**
   * get one sensor
   * @param element
   * @returns {*}
   */

  var getSensor = function getSensor(element) {
    var sensorId = element.getAttribute(_constant.SizeSensorId); // 1. if the sensor exists, then use it

    if (sensorId && Sensors[sensorId]) {
      return Sensors[sensorId];
    } // 2. not exist, then create one


    var newId = (0, _id["default"])();
    element.setAttribute(_constant.SizeSensorId, newId);
    var sensor = (0, _sensors.createSensor)(element); // add sensor into pool

    Sensors[newId] = sensor;
    return sensor;
  };
  /**
   * 移除 sensor
   * @param sensor
   */


  sensorPool.getSensor = getSensor;

  var removeSensor = function removeSensor(sensor) {
    var sensorId = sensor.element.getAttribute(_constant.SizeSensorId); // remove attribute

    sensor.element.removeAttribute(_constant.SizeSensorId); // remove event, dom of the sensor used

    sensor.destroy(); // exist, then remove from pool

    if (sensorId && Sensors[sensorId]) {
      delete Sensors[sensorId];
    }
  };

  sensorPool.removeSensor = removeSensor;

  Object.defineProperty(lib, "__esModule", {
    value: true
  });
  lib.ver = clear_1 = lib.clear = bind_1 = lib.bind = void 0;

  var _sensorPool = sensorPool;

  /**
   * Created by hustcc on 18/6/9.[高考时间]
   * Contract: i@hust.cc
   */

  /**
   * bind an element with resize callback function
   * @param {*} element
   * @param {*} cb
   */
  var bind = function bind(element, cb) {
    var sensor = (0, _sensorPool.getSensor)(element); // listen with callback

    sensor.bind(cb); // return unbind function

    return function () {
      sensor.unbind(cb);
    };
  };
  /**
   * clear all the listener and sensor of an element
   * @param element
   */


  var bind_1 = lib.bind = bind;

  var clear = function clear(element) {
    var sensor = (0, _sensorPool.getSensor)(element);
    (0, _sensorPool.removeSensor)(sensor);
  };

  var clear_1 = lib.clear = clear;
  var ver = "1.0.1";
  lib.ver = ver;

  /**
   * 保留 object 中的部分内容
   * @param obj
   * @param keys
   */
  function pick(obj, keys) {
      var r = {};
      keys.forEach(function (key) {
          r[key] = obj[key];
      });
      return r;
  }

  function isFunction(v) {
      return typeof v === 'function';
  }

  function isString(v) {
      return typeof v === 'string';
  }

  // do not edit .js files directly - edit src/index.jst



  var fastDeepEqual = function equal(a, b) {
    if (a === b) return true;

    if (a && b && typeof a == 'object' && typeof b == 'object') {
      if (a.constructor !== b.constructor) return false;

      var length, i, keys;
      if (Array.isArray(a)) {
        length = a.length;
        if (length != b.length) return false;
        for (i = length; i-- !== 0;)
          if (!equal(a[i], b[i])) return false;
        return true;
      }



      if (a.constructor === RegExp) return a.source === b.source && a.flags === b.flags;
      if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf();
      if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();

      keys = Object.keys(a);
      length = keys.length;
      if (length !== Object.keys(b).length) return false;

      for (i = length; i-- !== 0;)
        if (!Object.prototype.hasOwnProperty.call(b, keys[i])) return false;

      for (i = length; i-- !== 0;) {
        var key = keys[i];

        if (!equal(a[key], b[key])) return false;
      }

      return true;
    }

    // true if both NaN, false otherwise
    return a!==a && b!==b;
  };

  /**
   * core component for echarts binding
   */
  var EChartsReactCore = /** @class */ (function (_super) {
      __extends(EChartsReactCore, _super);
      function EChartsReactCore(props) {
          var _this = _super.call(this, props) || this;
          _this.echarts = props.echarts;
          _this.ele = null;
          _this.isInitialResize = true;
          return _this;
      }
      EChartsReactCore.prototype.componentDidMount = function () {
          this.renderNewEcharts();
      };
      // update
      EChartsReactCore.prototype.componentDidUpdate = function (prevProps) {
          /**
           * if shouldSetOption return false, then return, not update echarts options
           * default is true
           */
          var shouldSetOption = this.props.shouldSetOption;
          if (isFunction(shouldSetOption) && !shouldSetOption(prevProps, this.props)) {
              return;
          }
          // 以下属性修改的时候，需要 dispose 之后再新建
          // 1. 切换 theme 的时候
          // 2. 修改 opts 的时候
          // 3. 修改 onEvents 的时候，这样可以取消所有之前绑定的事件 issue #151
          if (!fastDeepEqual(prevProps.theme, this.props.theme) ||
              !fastDeepEqual(prevProps.opts, this.props.opts) ||
              !fastDeepEqual(prevProps.onEvents, this.props.onEvents)) {
              this.dispose();
              this.renderNewEcharts(); // 重建
              return;
          }
          // when these props are not isEqual, update echarts
          var pickKeys = ['option', 'notMerge', 'lazyUpdate', 'showLoading', 'loadingOption'];
          if (!fastDeepEqual(pick(this.props, pickKeys), pick(prevProps, pickKeys))) {
              this.updateEChartsOption();
          }
          /**
           * when style or class name updated, change size.
           */
          if (!fastDeepEqual(prevProps.style, this.props.style) || !fastDeepEqual(prevProps.className, this.props.className)) {
              this.resize();
          }
      };
      EChartsReactCore.prototype.componentWillUnmount = function () {
          this.dispose();
      };
      /**
       * return the echart object
       * 1. if exist, return the existed instance
       * 2. or new one instance
       */
      EChartsReactCore.prototype.getEchartsInstance = function () {
          return this.echarts.getInstanceByDom(this.ele) || this.echarts.init(this.ele, this.props.theme, this.props.opts);
      };
      /**
       * dispose echarts and clear size-sensor
       */
      EChartsReactCore.prototype.dispose = function () {
          if (this.ele) {
              try {
                  clear_1(this.ele);
              }
              catch (e) {
                  console.warn(e);
              }
              // dispose echarts instance
              this.echarts.dispose(this.ele);
          }
      };
      /**
       * render a new echarts instance
       */
      EChartsReactCore.prototype.renderNewEcharts = function () {
          var _this = this;
          var _a = this.props, onEvents = _a.onEvents, onChartReady = _a.onChartReady;
          // 1. new echarts instance
          var echartsInstance = this.updateEChartsOption();
          // 2. bind events
          this.bindEvents(echartsInstance, onEvents || {});
          // 3. on chart ready
          if (isFunction(onChartReady))
              onChartReady(echartsInstance);
          // 4. on resize
          if (this.ele) {
              bind_1(this.ele, function () {
                  _this.resize();
              });
          }
      };
      // bind the events
      EChartsReactCore.prototype.bindEvents = function (instance, events) {
          function _bindEvent(eventName, func) {
              // ignore the event config which not satisfy
              if (isString(eventName) && isFunction(func)) {
                  // binding event
                  instance.on(eventName, function (param) {
                      func(param, instance);
                  });
              }
          }
          // loop and bind
          for (var eventName in events) {
              if (Object.prototype.hasOwnProperty.call(events, eventName)) {
                  _bindEvent(eventName, events[eventName]);
              }
          }
      };
      /**
       * render the echarts
       */
      EChartsReactCore.prototype.updateEChartsOption = function () {
          var _a = this.props, option = _a.option, _b = _a.notMerge, notMerge = _b === void 0 ? false : _b, _c = _a.lazyUpdate, lazyUpdate = _c === void 0 ? false : _c, showLoading = _a.showLoading, _d = _a.loadingOption, loadingOption = _d === void 0 ? null : _d;
          // 1. get or initial the echarts object
          var echartInstance = this.getEchartsInstance();
          // 2. set the echarts option
          echartInstance.setOption(option, notMerge, lazyUpdate);
          // 3. set loading mask
          if (showLoading)
              echartInstance.showLoading(loadingOption);
          else
              echartInstance.hideLoading();
          return echartInstance;
      };
      /**
       * resize wrapper
       */
      EChartsReactCore.prototype.resize = function () {
          // 1. get the echarts object
          var echartsInstance = this.getEchartsInstance();
          // 2. call echarts instance resize if not the initial resize
          // resize should not happen on first render as it will cancel initial echarts animations
          if (!this.isInitialResize) {
              try {
                  echartsInstance.resize();
              }
              catch (e) {
                  console.warn(e);
              }
          }
          // 3. update variable for future calls
          this.isInitialResize = false;
      };
      EChartsReactCore.prototype.render = function () {
          var _this = this;
          var _a = this.props, style = _a.style, _b = _a.className, className = _b === void 0 ? '' : _b;
          // default height = 300
          var newStyle = __assign({ height: 300 }, style);
          return (React__default["default"].createElement("div", { ref: function (e) {
                  _this.ele = e;
              }, style: newStyle, className: "echarts-for-react " + className }));
      };
      return EChartsReactCore;
  }(React.PureComponent));

  // export the Component the echarts Object.
  var EChartsReact = /** @class */ (function (_super) {
      __extends(EChartsReact, _super);
      function EChartsReact(props) {
          var _this = _super.call(this, props) || this;
          // 初始化为 echarts 整个包
          _this.echarts = echarts__namespace;
          return _this;
      }
      return EChartsReact;
  }(EChartsReactCore));

  var __defProp = Object.defineProperty;
  var __getOwnPropSymbols = Object.getOwnPropertySymbols;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __propIsEnum = Object.prototype.propertyIsEnumerable;
  var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
  var __spreadValues = (a, b) => {
    for (var prop in b || (b = {}))
      if (__hasOwnProp.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    if (__getOwnPropSymbols)
      for (var prop of __getOwnPropSymbols(b)) {
        if (__propIsEnum.call(b, prop))
          __defNormalProp(a, prop, b[prop]);
      }
    return a;
  };
  var __objRest = (source, exclude) => {
    var target = {};
    for (var prop in source)
      if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
        target[prop] = source[prop];
    if (source != null && __getOwnPropSymbols)
      for (var prop of __getOwnPropSymbols(source)) {
        if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
          target[prop] = source[prop];
      }
    return target;
  };
  const Stack = React.forwardRef((props, ref) => {
    const _a = props, {
      context,
      dimension,
      compareDimension,
      valueList,
      echartsSeries,
      setOption,
      xAxisData,
      isPercentMode,
      isLineStack
    } = _a, restSettings = __objRest(_a, [
      "context",
      "dimension",
      "compareDimension",
      "valueList",
      "echartsSeries",
      "setOption",
      "xAxisData",
      "isPercentMode",
      "isLineStack"
    ]);
    const { data, echartsOptions, echartsOptionsBase: chartOption, userOptions } = React.useContext(context);
    const _b = echartsOptions || {}, resetOptions = __objRest(_b, ["option"]);
    if (!data) {
      return null;
    }
    if ((valueList == null ? void 0 : valueList.length) === 0) {
      return null;
    }
    const _dimension = dimension && dimension.slice(0, 1);
    const _valueItem = valueList && valueList[0];
    const _chartOption = cloneDeep(chartOption || {});
    if (!(_dimension && _valueItem && _dimension.length === 1)) {
      return null;
    }
    if (_chartOption) {
      let _dataXAxis = [
        ...new Set(data == null ? void 0 : data.map((d) => {
          return _dimension && d[_dimension[0].fieldKey];
        }))
      ];
      let _preProcessData = [];
      let _processData = [];
      let sumData = [];
      let compareDimensionValues = [];
      if (compareDimension && compareDimension.length > 0) {
        compareDimensionValues = [...new Set(data == null ? void 0 : data.map((d) => d[compareDimension[0].fieldKey]))];
        data == null ? void 0 : data.forEach((d) => {
          const _index = _preProcessData.findIndex((item) => item.name == (_dimension && d[_dimension[0].fieldKey]));
          if (_index != -1) {
            const _indexCompareDimensionData = _preProcessData[_index].data.findIndex((item) => item[compareDimension[0] && compareDimension[0].fieldKey] == d[compareDimension[0] && compareDimension[0].fieldKey]);
            if (_indexCompareDimensionData != -1) {
              _preProcessData[_index].data[_indexCompareDimensionData][_valueItem.fieldKey] += d[_valueItem.fieldKey];
            } else {
              _preProcessData[_index].data.push(d);
            }
          } else {
            _preProcessData.push({
              name: d[_dimension[0] && _dimension[0].fieldKey],
              data: [d]
            });
          }
        });
        try {
          _preProcessData = _preProcessData.sort((a, b) => {
            const sumA = a.data.reduce((s, c) => {
              s = s + (c[_valueItem.fieldKey] || 0);
              return s;
            }, 0);
            const sumB = b.data.reduce((s, c) => {
              s = s + (c[_valueItem.fieldKey] || 0);
              return s;
            }, 0);
            return sumB - sumA;
          });
          _dataXAxis = _preProcessData.map((item) => {
            return item.name;
          });
        } catch (e) {
        }
        _processData = compareDimensionValues.map((item) => {
          return {
            name: `${item}`,
            data: _preProcessData.map((pd) => {
              const v = pd.data.find((d) => d[compareDimension[0] && compareDimension[0].fieldKey] == item);
              if (v) {
                return v;
              } else {
                const _v = {};
                if (_dimension && _dimension.length > 0) {
                  _v[_dimension[0] && _dimension[0].fieldKey] = pd.name;
                }
                return _v;
              }
            })
          };
        });
        sumData = _preProcessData.map((item, i) => {
          return {
            name: item.name,
            value: item.data.reduce((s, c) => s + c[_valueItem.fieldKey], 0)
          };
        });
        _chartOption.xAxis.data = xAxisData || _dataXAxis;
        _chartOption.yAxis = [
          {
            show: true,
            type: "value",
            name: "",
            scale: true,
            splitLine: {
              show: true,
              lineStyle: {
                color: "#E7EAEF"
              }
            },
            axisLine: {
              show: true,
              lineStyle: {}
            },
            axisLabel: {},
            axisTick: {
              lineStyle: {}
            },
            min: 0,
            max: isPercentMode ? 100 : null
          },
          {
            show: false,
            type: "value",
            name: "",
            scale: true,
            splitLine: {
              show: false,
              lineStyle: {}
            },
            axisLine: {
              show: true,
              lineStyle: {}
            },
            axisLabel: {},
            axisTick: {
              lineStyle: {}
            },
            min: 0
          }
        ];
        _chartOption.series = echartsSeries || _processData.map((item) => {
          let _dataClone = cloneDeep(item.data) || [];
          let text = item.name;
          return {
            name: text,
            type: isLineStack ? "line" : "bar",
            stack: "\u603B\u91CF",
            areaStyle: {},
            data: _dataClone.map((d, i) => {
              let _value;
              try {
                _value = isPercentMode ? (d && d[_valueItem.fieldKey] || 0) / sumData[i].value * 100 : d && d[_valueItem.fieldKey] || 0;
              } catch (error) {
                _value = 0;
              }
              return {
                value: _value,
                label: {
                  show: false,
                  position: "inside",
                  fontSize: 10,
                  formatter: function(data2) {
                    if (isPercentMode) {
                      return data2.value != null && !isNaN(data2.value) ? `${numberWithCommas(Big__default["default"](data2.value).round(2).toNumber())}%` : "--%";
                    }
                    try {
                      return data2.value != null && !isNaN(data2.value) ? numberWithCommas(Big__default["default"](data2.value).round(2).toNumber()) : "--";
                    } catch (e) {
                      return data2.value || "--";
                    }
                  }
                },
                decimalLength: _valueItem.decimalLength || 0,
                isPercent: _valueItem.isPercent
              };
            })
          };
        });
      } else {
        const dataMatrix = valueList.map((item, i) => {
          return data == null ? void 0 : data.map((d) => d[item.fieldKey]);
        });
        dataMatrix.forEach((list) => {
          list == null ? void 0 : list.forEach((d, i) => {
            sumData[i] = (sumData[i] || 0) + d;
          });
        });
        _chartOption.xAxis.data = xAxisData || _dataXAxis;
        _chartOption.yAxis = [
          {
            show: true,
            type: "value",
            name: "",
            scale: true,
            splitLine: {
              show: true,
              lineStyle: {
                color: "#E7EAEF"
              }
            },
            axisLine: {
              show: true,
              lineStyle: {}
            },
            axisLabel: {},
            axisTick: {
              lineStyle: {}
            },
            min: 0,
            max: isPercentMode ? 100 : null
          },
          {
            show: false,
            type: "value",
            name: "",
            scale: true,
            splitLine: {
              show: false,
              lineStyle: {}
            },
            axisLine: {
              show: true,
              lineStyle: {}
            },
            axisLabel: {},
            axisTick: {
              lineStyle: {}
            },
            min: 0
          }
        ];
        _chartOption.series = echartsSeries || valueList.map((item, i) => {
          return {
            name: item.fieldName,
            type: isLineStack ? "line" : "bar",
            stack: "\u603B\u91CF",
            areaStyle: {},
            data: data == null ? void 0 : data.map((d, j) => {
              let _value;
              try {
                _value = Big__default["default"](isPercentMode ? d[item.fieldKey] / sumData[j] * 100 : d[item.fieldKey]).round(item.decimalLength || 0).toNumber();
              } catch (error) {
                _value = 0;
              }
              return {
                value: _value,
                label: {
                  show: false,
                  position: "inside",
                  fontSize: 10,
                  formatter: function(params) {
                    if (isPercentMode) {
                      try {
                        return params.value != null && !isNaN(params.value) ? `${numberWithCommas(Big__default["default"](params.value).round(item.decimalLength || 0).toNumber())}%` : "--%";
                      } catch (e) {
                        return params.value || "--%";
                      }
                    }
                    try {
                      return params.value != null && !isNaN(params.value) ? numberWithCommas(Big__default["default"](params.value).round(item.decimalLength || 0).toNumber()) : "--";
                    } catch (e) {
                      return params.value || "--";
                    }
                  }
                },
                decimalLength: item.decimalLength || 0,
                isPercent: item.isPercent
              };
            })
          };
        });
      }
    }
    const builtOption = buildChartOption(_chartOption, restSettings, isLineStack ? "line-stack" : "stack");
    let options = mergeOption(builtOption, userOptions);
    if (setOption) {
      options = setOption(cloneDeep(options));
    }
    const [reactEchartsNode, setReactEchartsNode] = React.useState(null);
    const reactEchartsRef = React.useCallback((node) => {
      if (node !== null) {
        setReactEchartsNode(node);
      }
    }, []);
    React.useImperativeHandle(ref, () => ({
      getEchartsInstance: () => {
        return reactEchartsNode == null ? void 0 : reactEchartsNode.getEchartsInstance();
      }
    }), [reactEchartsNode]);
    return /* @__PURE__ */ React__default["default"].createElement(React__default["default"].Fragment, null, /* @__PURE__ */ React__default["default"].createElement(EChartsReact, __spreadValues({
      ref: reactEchartsRef,
      option: __spreadValues({}, cloneDeep(options)),
      notMerge: true,
      opts: { renderer: "svg" },
      style: { height: "100%", width: "100%" }
    }, resetOptions)));
  });

  exports.Stack = Stack;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
